/*
 * PM - 2017
 * lab0.c
 */

#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6

#define MORSE_LUNG		150
#define MORSE_SCURT		50
#define MORSE_PAUZA		50

#define NUM_NOTE		8

int frecventa_nota[NUM_NOTE] = {
	262, 294, 330, 349, 392, 440, 494, 523
};

/* Aprinde led-ul PC0 la apasarea butonului PB0. */
void getsecv(){

	

}

/* Genereaza o nota folosind buzzer-ul. */
void buzzer_reda(int nota) {
	int perioada_nota = 1000000 / frecventa_nota[nota];
	int i;

	/*
	 * Nu putem folosi variable ca argument pentru functia
	 * _delay_us(), asa ca folosim acest "workaround".
	 */
	 PORTC |= (1 << PC0);
	for (i = 0; i < perioada_nota / 2; ++i)
		_delay_us(1);

	PORTC &= ~(1 << PC0);
	for (i = 0; i < perioada_nota / 2; ++i)
		_delay_us(1);
}

void exemplu(void) {
		/* Setez pinul PB0 ca intrare. */
	/* Setez pinul PB0 ca intrare. */
	DDRA &= ~(1 << PA7);
	DDRA &= ~(1 << PA6);
	DDRA &= ~(1 << PA5);
	DDRA &= ~(1 << PA4);
	DDRA &= ~(1 << PA3);
	DDRA &= ~(1 << PA2);
	DDRA &= ~(1 << PA1);
	DDRA &= ~(1 << PA0);
	/* Activez rezistenta de pull-up . */
	PORTA |= (1 << PA7);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA0);
	
	/* Setez pinul PC0 ca iesire. */
	DDRC |= (1 << PC0);

	DDRB |= (1 << PB7);
	DDRB |= (1 << PB6);
	DDRB |= (1 << PB5);
	DDRB |= (1 << PB4);
	DDRB |= (1 << PB3);
	DDRB |= (1 << PB2);
	DDRB |= (1 << PB1);
	DDRB |= (1 << PB0);
	
	/* Sting LED-ul. */
	PORTB &= ~(1 << PB7);
	PORTB &= ~(1 << PB6);
	PORTB &= ~(1 << PB5);
	PORTB &= ~(1 << PB4);
	PORTB &= ~(1 << PB3);
	PORTB &= ~(1 << PB2);
	PORTB &= ~(1 << PB1);
	PORTB &= ~(1 << PB0);

	while (1) {
		/* Daca butonul este apasat. */
		if ((PINA & (1 << PA7)) == 0){
			/* Aprind LED-ul. */
			PORTB |= (1 << PB7);
			buzzer_reda(7);
		}
			
		else
			/* Sting LED-ul. */
			PORTB &= ~(1 << PB7);
			
		
		if ((PINA & (1 << PA6)) == 0){
			/* Aprind LED-ul. */
			PORTB |= (1 << PB6);
			buzzer_reda(6);
		}
			
		else
			/* Sting LED-ul. */
			PORTB &= ~(1 << PB6);
		
		if ((PINA & (1 << PA5)) == 0){
			/* Aprind LED-ul. */
			PORTB |= (1 << PB5);
			buzzer_reda(5);
		}
			
		else
			/* Sting LED-ul. */
			PORTB &= ~(1 << PB5);
		
		if ((PINA & (1 << PA4)) == 0){
			/* Aprind LED-ul. */
			PORTB |= (1 << PB4);
			buzzer_reda(4);
		}
			
		else
			/* Sting LED-ul. */
			PORTB &= ~(1 << PB4);
		
		if ((PINA & (1 << PA3)) == 0){
			/* Aprind LED-ul. */
			PORTB |= (1 << PB3);
			buzzer_reda(3);
		}
			
		else
			/* Sting LED-ul. */
			PORTB &= ~(1 << PB3);
		
		if ((PINA & (1 << PA2)) == 0){
			/* Aprind LED-ul. */
			PORTB |= (1 << PB2);
			buzzer_reda(2);
		}
			
		else
			/* Sting LED-ul. */
			PORTB &= ~(1 << PB2);
		
		if ((PINA & (1 << PA1)) == 0){
			/* Aprind LED-ul. */
			PORTB |= (1 << PB1);
			buzzer_reda(1);
		}
			
		else
			/* Sting LED-ul. */
			PORTB &= ~(1 << PB1);
		
		if ((PINA & (1 << PA0)) == 0){
			/* Aprind LED-ul. */
			PORTB |= (1 << PB0);
			buzzer_reda(0);
		}
			
		else
			/* Sting LED-ul. */
			PORTB &= ~(1 << PB0);
	}
	
}








int main(void) {
	
	exemplu();
	//task1();
	//task2();
	/*task3();*/

	return 0;
}
